//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: ibc/core/client/v1/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the ibc/client Msg service.
///
/// Usage: instantiate `Ibc_Core_Client_V1_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Ibc_Core_Client_V1_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Ibc_Core_Client_V1_MsgClientInterceptorFactoryProtocol? { get }

  func createClient(
    _ request: Ibc_Core_Client_V1_MsgCreateClient,
    callOptions: CallOptions?
  ) -> UnaryCall<Ibc_Core_Client_V1_MsgCreateClient, Ibc_Core_Client_V1_MsgCreateClientResponse>

  func updateClient(
    _ request: Ibc_Core_Client_V1_MsgUpdateClient,
    callOptions: CallOptions?
  ) -> UnaryCall<Ibc_Core_Client_V1_MsgUpdateClient, Ibc_Core_Client_V1_MsgUpdateClientResponse>

  func upgradeClient(
    _ request: Ibc_Core_Client_V1_MsgUpgradeClient,
    callOptions: CallOptions?
  ) -> UnaryCall<Ibc_Core_Client_V1_MsgUpgradeClient, Ibc_Core_Client_V1_MsgUpgradeClientResponse>

  func submitMisbehaviour(
    _ request: Ibc_Core_Client_V1_MsgSubmitMisbehaviour,
    callOptions: CallOptions?
  ) -> UnaryCall<Ibc_Core_Client_V1_MsgSubmitMisbehaviour, Ibc_Core_Client_V1_MsgSubmitMisbehaviourResponse>
}

extension Ibc_Core_Client_V1_MsgClientProtocol {
  internal var serviceName: String {
    return "ibc.core.client.v1.Msg"
  }

  /// CreateClient defines a rpc handler method for MsgCreateClient.
  ///
  /// - Parameters:
  ///   - request: Request to send to CreateClient.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func createClient(
    _ request: Ibc_Core_Client_V1_MsgCreateClient,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Ibc_Core_Client_V1_MsgCreateClient, Ibc_Core_Client_V1_MsgCreateClientResponse> {
    return self.makeUnaryCall(
      path: "/ibc.core.client.v1.Msg/CreateClient",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeCreateClientInterceptors() ?? []
    )
  }

  /// UpdateClient defines a rpc handler method for MsgUpdateClient.
  ///
  /// - Parameters:
  ///   - request: Request to send to UpdateClient.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func updateClient(
    _ request: Ibc_Core_Client_V1_MsgUpdateClient,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Ibc_Core_Client_V1_MsgUpdateClient, Ibc_Core_Client_V1_MsgUpdateClientResponse> {
    return self.makeUnaryCall(
      path: "/ibc.core.client.v1.Msg/UpdateClient",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeUpdateClientInterceptors() ?? []
    )
  }

  /// UpgradeClient defines a rpc handler method for MsgUpgradeClient.
  ///
  /// - Parameters:
  ///   - request: Request to send to UpgradeClient.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func upgradeClient(
    _ request: Ibc_Core_Client_V1_MsgUpgradeClient,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Ibc_Core_Client_V1_MsgUpgradeClient, Ibc_Core_Client_V1_MsgUpgradeClientResponse> {
    return self.makeUnaryCall(
      path: "/ibc.core.client.v1.Msg/UpgradeClient",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeUpgradeClientInterceptors() ?? []
    )
  }

  /// SubmitMisbehaviour defines a rpc handler method for MsgSubmitMisbehaviour.
  ///
  /// - Parameters:
  ///   - request: Request to send to SubmitMisbehaviour.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func submitMisbehaviour(
    _ request: Ibc_Core_Client_V1_MsgSubmitMisbehaviour,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Ibc_Core_Client_V1_MsgSubmitMisbehaviour, Ibc_Core_Client_V1_MsgSubmitMisbehaviourResponse> {
    return self.makeUnaryCall(
      path: "/ibc.core.client.v1.Msg/SubmitMisbehaviour",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeSubmitMisbehaviourInterceptors() ?? []
    )
  }
}

internal protocol Ibc_Core_Client_V1_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'createClient'.
  func makeCreateClientInterceptors() -> [ClientInterceptor<Ibc_Core_Client_V1_MsgCreateClient, Ibc_Core_Client_V1_MsgCreateClientResponse>]

  /// - Returns: Interceptors to use when invoking 'updateClient'.
  func makeUpdateClientInterceptors() -> [ClientInterceptor<Ibc_Core_Client_V1_MsgUpdateClient, Ibc_Core_Client_V1_MsgUpdateClientResponse>]

  /// - Returns: Interceptors to use when invoking 'upgradeClient'.
  func makeUpgradeClientInterceptors() -> [ClientInterceptor<Ibc_Core_Client_V1_MsgUpgradeClient, Ibc_Core_Client_V1_MsgUpgradeClientResponse>]

  /// - Returns: Interceptors to use when invoking 'submitMisbehaviour'.
  func makeSubmitMisbehaviourInterceptors() -> [ClientInterceptor<Ibc_Core_Client_V1_MsgSubmitMisbehaviour, Ibc_Core_Client_V1_MsgSubmitMisbehaviourResponse>]
}

internal final class Ibc_Core_Client_V1_MsgClient: Ibc_Core_Client_V1_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Ibc_Core_Client_V1_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the ibc.core.client.v1.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Ibc_Core_Client_V1_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the ibc/client Msg service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Ibc_Core_Client_V1_MsgProvider: CallHandlerProvider {
  var interceptors: Ibc_Core_Client_V1_MsgServerInterceptorFactoryProtocol? { get }

  /// CreateClient defines a rpc handler method for MsgCreateClient.
  func createClient(request: Ibc_Core_Client_V1_MsgCreateClient, context: StatusOnlyCallContext) -> EventLoopFuture<Ibc_Core_Client_V1_MsgCreateClientResponse>

  /// UpdateClient defines a rpc handler method for MsgUpdateClient.
  func updateClient(request: Ibc_Core_Client_V1_MsgUpdateClient, context: StatusOnlyCallContext) -> EventLoopFuture<Ibc_Core_Client_V1_MsgUpdateClientResponse>

  /// UpgradeClient defines a rpc handler method for MsgUpgradeClient.
  func upgradeClient(request: Ibc_Core_Client_V1_MsgUpgradeClient, context: StatusOnlyCallContext) -> EventLoopFuture<Ibc_Core_Client_V1_MsgUpgradeClientResponse>

  /// SubmitMisbehaviour defines a rpc handler method for MsgSubmitMisbehaviour.
  func submitMisbehaviour(request: Ibc_Core_Client_V1_MsgSubmitMisbehaviour, context: StatusOnlyCallContext) -> EventLoopFuture<Ibc_Core_Client_V1_MsgSubmitMisbehaviourResponse>
}

extension Ibc_Core_Client_V1_MsgProvider {
  internal var serviceName: Substring { return "ibc.core.client.v1.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "CreateClient":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Ibc_Core_Client_V1_MsgCreateClient>(),
        responseSerializer: ProtobufSerializer<Ibc_Core_Client_V1_MsgCreateClientResponse>(),
        interceptors: self.interceptors?.makeCreateClientInterceptors() ?? [],
        userFunction: self.createClient(request:context:)
      )

    case "UpdateClient":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Ibc_Core_Client_V1_MsgUpdateClient>(),
        responseSerializer: ProtobufSerializer<Ibc_Core_Client_V1_MsgUpdateClientResponse>(),
        interceptors: self.interceptors?.makeUpdateClientInterceptors() ?? [],
        userFunction: self.updateClient(request:context:)
      )

    case "UpgradeClient":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Ibc_Core_Client_V1_MsgUpgradeClient>(),
        responseSerializer: ProtobufSerializer<Ibc_Core_Client_V1_MsgUpgradeClientResponse>(),
        interceptors: self.interceptors?.makeUpgradeClientInterceptors() ?? [],
        userFunction: self.upgradeClient(request:context:)
      )

    case "SubmitMisbehaviour":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Ibc_Core_Client_V1_MsgSubmitMisbehaviour>(),
        responseSerializer: ProtobufSerializer<Ibc_Core_Client_V1_MsgSubmitMisbehaviourResponse>(),
        interceptors: self.interceptors?.makeSubmitMisbehaviourInterceptors() ?? [],
        userFunction: self.submitMisbehaviour(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Ibc_Core_Client_V1_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'createClient'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeCreateClientInterceptors() -> [ServerInterceptor<Ibc_Core_Client_V1_MsgCreateClient, Ibc_Core_Client_V1_MsgCreateClientResponse>]

  /// - Returns: Interceptors to use when handling 'updateClient'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeUpdateClientInterceptors() -> [ServerInterceptor<Ibc_Core_Client_V1_MsgUpdateClient, Ibc_Core_Client_V1_MsgUpdateClientResponse>]

  /// - Returns: Interceptors to use when handling 'upgradeClient'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeUpgradeClientInterceptors() -> [ServerInterceptor<Ibc_Core_Client_V1_MsgUpgradeClient, Ibc_Core_Client_V1_MsgUpgradeClientResponse>]

  /// - Returns: Interceptors to use when handling 'submitMisbehaviour'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeSubmitMisbehaviourInterceptors() -> [ServerInterceptor<Ibc_Core_Client_V1_MsgSubmitMisbehaviour, Ibc_Core_Client_V1_MsgSubmitMisbehaviourResponse>]
}
